/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define DISPLAY 1
#include "ssd1306.h"
#define DISPLAY_ADDRESS 0x3C
float ReflectometerReading;
float threshold[5]={480,1040,1680,3040,4200};


//Leds
#define NUMBER_OF_PINS  5
GPIO_PRT_Type* led_Port[NUMBER_OF_PINS] = {P10_4_PORT,P10_6_PORT,P10_5_PORT,P10_1_PORT,P10_0_PORT};
uint led_pin[NUMBER_OF_PINS] = {P10_4_PIN,P10_6_PIN,P10_5_PIN,P10_1_PIN,P10_0_PIN};

uint32 Custom_GetAllPinStatus(void)

{

    uint32 retStatus = 0;

   

    for(uint32 index = 0; index < NUMBER_OF_PINS; index++)

    {

        retStatus |= ((Cy_GPIO_Read(led_Port[index], led_pin[index]))<<index);

    }

   

    return retStatus;

}
//switch
#define NUMBER_SW_PINS  2
GPIO_PRT_Type* SW_Port[NUMBER_SW_PINS] = {P10_3_PORT,P6_3_PORT};
uint SW_pin[NUMBER_SW_PINS] = {P10_3_PIN,P6_3_PIN};

uint32 Custom_GetAllPinStatus1(void)

{

    uint32 retStatus1 = 0;

   

    for(uint32 ind = 0; ind < NUMBER_SW_PINS; ind++)

    {

        retStatus1 |= ((Cy_GPIO_Read(SW_Port[ind], SW_pin[ind]))<<ind);

    }

   

    return retStatus1;

}
void update_LEDs();
void scanKeys();
void screen();

int main(void)
{
    __enable_irq(); /* Enable global interrupts. */
    
    char buffer[100];
   
        I2COLED_Start();
        display_init(DISPLAY_ADDRESS);
       display_clear();
       
        gfx_setTextSize(2);
            gfx_setTextColor(WHITE);
            gfx_setCursor(0,5);
            sprintf(buffer, "ANS");
            gfx_println(buffer);
        display_update();
        CyDelay(3000);
        display_clear();
        screen();
        update_LEDs();
        scanKeys();
        
  }   

void read_AD8307()
{
  ReflectometerReading=4;
    
}
void reset_LEDs() {
   //Turn off all LEDs
    for (int i=0; i< NUMBER_OF_PINS; i++)
    
    {
        Cy_GPIO_SetDrivemode(led_Port[i], led_pin[i], CY_GPIO_DM_OD_DRIVESLOW);
        Cy_GPIO_Write(led_Port[i], led_pin[i],0); //This to make led turn off.
  
    }
}
    


    
void update_LEDs(){
   reset_LEDs();
//Led will light according to the threshold
   for (int l=0; l<NUMBER_OF_PINS;l++)
    {
        if(ReflectometerReading>=threshold[l])
        {
            Cy_GPIO_SetDrivemode(led_Port[l], led_pin[l], CY_GPIO_DM_OD_DRIVESHIGH);
            Cy_GPIO_Write(led_Port[l], led_pin[l],1); // this is to turn on the led.
	    }
    }
}


//switch
void scanKeys(){
    int x;
    for (int k=0; k<=NUMBER_SW_PINS; k++) {
    x= Cy_GPIO_Read(SW_Port[k], SW_pin[k]); // here x will store what is status of switch port.
    
}
}


void screen()
{
    
    while (1) {
       scanKeys();
    if (!x[0]) //if key is pressed, display measurementin screen
    {  read_AD8307();
    display_clear();
     char buffer[100];
    gfx_setTextSize(2);
            gfx_setTextColor(WHITE);
            gfx_setCursor(0,20);
            sprintf(buffer,"R = %f",ReflectometerReading);
            gfx_println(buffer);
            update_LEDs();
            display_update();
            CyDelay(3000);
            reset_LEDs();
            display_clear();}
    //If not pressed display N/A
    else if (x[0]) {
        display_clear();
     char buffer[100];
    gfx_setTextSize(2);
            gfx_setTextColor(WHITE);
            gfx_setCursor(0,20);
            sprintf(buffer, "R=N/A");
            gfx_println(buffer);
            display_update();
            display_clear();
        
        
            
}

